package org.div8.dictionary;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;

public class DictClientSocket {
	Socket socket;
	PrintWriter out;
	BufferedReader in;
	
	void initializeSocket(String hostname, int port) throws IOException {		
		socket = new Socket(hostname, port);
		out = new PrintWriter(socket.getOutputStream(), true);
		in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
	}
	
	DictClientSocket(String hostname, int port) throws IOException {
		initializeSocket(hostname, port);
		readHeader();
	}

	DictClientSocket(String hostname) throws IOException {
		initializeSocket(hostname, 2628);
		readHeader();
	}
	
	boolean readHeader() throws IOException {
		String header = in.readLine();
		return header.startsWith("2");
	}

	String getDefinition(String word) throws IOException {
		String definition = "";
		String curline;
		out.println("DEFINE ! " + word);
		for(;;) {
			curline = in.readLine();
			if( curline.startsWith("4") || curline.startsWith("5") || curline.startsWith("2")) {
				return curline.substring(4);
			} else if( !curline.startsWith("1") ) {
				break;
			}
		}
		for(;;) {
			if( curline.equals(".") ) break;
			if( curline.startsWith("..") ) {
				curline = curline.substring(1);
			}
			definition = definition + curline + "\n";
			curline = in.readLine();
		}
		return definition;
	}

	String getDatabases(String word) throws IOException {
		String definition = "";
		String curline;
		out.println("SHOW DB");
		for(;;) {
			curline = in.readLine();
			if( curline.startsWith("4") || curline.startsWith("5") || curline.startsWith("2")) {
				return curline.substring(4);
			} else if( !curline.startsWith("1") ) {
				break;
			}
		}
		for(;;) {
			if( curline.equals(".") ) break;
			if( curline.startsWith("..") ) {
				curline = curline.substring(1);
			}
			definition = definition + curline + "\n";
			curline = in.readLine();
		}
		return definition;
	}

	void shutDown() throws IOException {
		out.println("QUIT");
		String response = in.readLine();
		socket.close();
	}
}
