package org.div8.dictionary;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

public class DictionaryApp {

	public static void main(String[] args) {
		Display display = new Display();
		Shell shell = new Shell(display);

		shell.setText("Dictionary");
		shell.setLayout(new FillLayout());
		
		DictionarySettings settings = new DictionarySettings();
		DefinitionView dv = new DefinitionView(settings, shell, SWT.NONE);
		final DictionaryPreferences prefs = new DictionaryPreferences(shell, settings);
		
		Menu topmenu = new Menu(shell,SWT.BAR);
		shell.setMenuBar(topmenu);
		MenuItem fileitem = new MenuItem(topmenu,SWT.CASCADE);
		fileitem.setText("&File");
		Menu filemenu = new Menu(shell,SWT.DROP_DOWN);
		fileitem.setMenu(filemenu);
		MenuItem quititem = new MenuItem(filemenu,SWT.PUSH);
		quititem.setText("&Quit\tCtrl+Q");
		quititem.setAccelerator(SWT.CTRL + 'Q');
		quititem.addListener(SWT.Selection, new Listener(){
			public void handleEvent(Event e) {
				System.exit(0);
			}
		});
		MenuItem tools = new MenuItem(topmenu,SWT.CASCADE);
		tools.setText("&Tools");
		Menu toolsmenu = new Menu(shell,SWT.DROP_DOWN);
		tools.setMenu(toolsmenu);
		MenuItem prefsitem = new MenuItem(toolsmenu,SWT.PUSH);
		prefsitem.setText("&Preferences");
		prefsitem.addListener(SWT.Selection, new Listener(){
			public void handleEvent(Event e) {
				prefs.show();
			}
		});

		shell.open();
		while( !shell.isDisposed() ) {
			if( !display.readAndDispatch()) display.sleep();
		}
		
		// Shutdown.
		display.dispose();
	}
}
