package org.div8.dictionary;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class DictionaryPreferences {
	Shell parent;
	Shell dialog = null;
	DictionarySettings settings;
	Text serverName;
	Text portNum;

	DictionaryPreferences(Shell dialogparent, DictionarySettings dictsettings) {
		parent = dialogparent;
		settings = dictsettings;
	}

	Control createMainPage(Composite parent) {
		Composite main = new Composite(parent, SWT.NONE);
		main.setLayoutData(new GridData(GridData.FILL_BOTH));
		main.setLayout(new GridLayout(2, false));

		Label serverLabel = new Label(main, SWT.NONE);
		serverLabel.setText("Dictionary Server");

		serverName = new Text(main, SWT.BORDER);
		serverName.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		serverName.setText(settings.server);
		
		Label portLabel = new Label(main, SWT.NONE);
		portLabel.setText("Port");

		portNum = new Text(main, SWT.BORDER);
		portNum.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		portNum.setText(String.valueOf(settings.portnum));
		
		Composite validate = new Composite(main, SWT.NONE);
		GridData valdata = new GridData(GridData.HORIZONTAL_ALIGN_END);
		valdata.horizontalSpan = 2;
		validate.setLayoutData(valdata);
		validate.setLayout(new GridLayout());

		Button valbutton = new Button(validate, SWT.PUSH);
		valbutton.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END));
		valbutton.setText("Check server");

		return main;
	}

	Control createButtonBar(Composite parent) {		
		Composite bottomrow = new Composite(parent,SWT.NONE);
		bottomrow.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END));
		bottomrow.setLayout(new GridLayout(2,true));

		Button ok = new Button(bottomrow, SWT.PUSH);
		ok.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		ok.setText("OK");
		ok.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent event) {
				saveChanges();
				dialog.dispose();
			}
		});

		Button cancel = new Button(bottomrow, SWT.PUSH);
		cancel.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		cancel.setText("Cancel");
		cancel.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent event) {
				dialog.dispose();
			}
		});

		return bottomrow;
	}

	void createDialog() {
		dialog = new Shell(parent);
		dialog.setLayout(new FillLayout());
		dialog.setText("Preferences");
		dialog.setSize(400,200);

		Composite toplevel = new Composite(dialog,SWT.NONE);
		toplevel.setLayout(new GridLayout());

		createMainPage(toplevel);
		createButtonBar(toplevel);

		dialog.open();
	}
	
	void saveChanges() {
		settings.server = serverName.getText();
		settings.portnum = new Integer(portNum.getText()).intValue(); 
	}

	void show() {
		if(dialog == null || dialog.isDisposed()) {
			createDialog();
		}
	}
}
